/*........................ global variables ..................................*/

int contrl[12];         /* needed by VDI and AES */
int intin[128];         /* needed by VDI and AES */
int ptsin[128];         /* needed by VDI and AES */
int intout[128];        /* needed by VDI and AES */
int ptsout[128];        /* needed by VDI and AES */
int gl_hand;            /* global identifier for this application */
int messbuf[8];         /* receives input from event library */
int dummy;              /* used for an int-sized place-holder */
int rez;                /* screen resolution = 0,1,2  = low,medium,high */
int wba_hand;           /* handle for workbank A window */
int wbb_hand;           /* handle for workbank B window */
int ws_hand;            /* handle for workspace window */
int cz_hand;            /* handle for CZ window */
char bankset;           /* CZ bank offset = $00,$10,$20,$30,$40,$50,$60 */
int syntype;            /* synth model # = 0,1,2,3   */
int midi_ch;            /* midi channel for cz-android transmission  = 0-15 */
long menuaddr;          /* pointer to tree which draws menu */
long midiaddr;          /* pointer to tree which draws midi channel dialogue */
long bankaddr;          /* pointer to tree which draws cz bank dialogue */
long fmtaddr;           /* pointer to tree which draws format dialogue */
long infoaddr;          /* pointer to tree which draws info dialogue */
long helpaddr;          /* pointer to tree which draws help dialogue */
long safeaddr;          /* pointer to tree which draws safety dialogue */
long lineaddr;          /* pointer to tree which draws czlines dialogue */
long envsaddr;          /* pointer to tree which draws czenvs dialogue */
char dir_def[39];       /* directory of next file to be requested */
char dir_temp[52];      /* a directory, or a full pathname */
char file_temp[13];     /* a file name */
char wba_dat[2432];     /* workbank A */
char wbb_dat[2432];     /* workbank B */
char tempbuf[2432];     /* temporary area for copying, synth i/o, etc. */
char czbuf[256];        /* area for denormalized data (over-sized) */
char ws_dat[152];       /* workspace */
char edittitl[60],editline[80];   /* title and info line for edit window */
int drive;              /* default drive = 0 A, = 1 B */
char diskbuf[8192];     /* disk i/o buffer, big enough for 1 track image */
int top_hand;           /* handle of topped window */
int act_slot;           /* selected slot = 1-17, 0 for none */
int work_x,work_y,work_w,work_h;   /* desktop window */
int saf_alls,saf_cz,saf_x;  /* safety levels */
int ws_x,ws_y,ws_w,ws_h;    /* workspace window saved during editing */
int editmode;           /* edit mode flag */
int editmon;            /* edit monitoring flag */
char filecode[4]= { 2,1,3,8 };   /* validates CZ-Android file */
int edited;             /* =1 edited version, =0 original version */
long saveptr;           /* points to screen save area */

int midijack[37] =      /* mouse for synth i/o in progress */
{  7,7,1,0,1,
   0x0000, 0x0660, 0x0e70, 0x1ff8,   /* mask */
   0x3ffc, 0x3ffc, 0x7ffe, 0x4ff2,
   0x4ff2, 0x7ffe, 0x33cc, 0x33cc,
   0x1e78, 0x0e70, 0x03c0, 0x0000, 
   0x07e0, 0x1998, 0x318c, 0x6006,   /* data */
   0x4002, 0xc003, 0x8001, 0xb00d,
   0xb00d, 0x8001, 0xcc33, 0x4c32,
   0x6186, 0x318c, 0x1c38, 0x07e0  };

char initvoic[135] =     /* initialized voice */
{
0,   /* line select 1 */
0,   /* octave 0 */
0,   /* detune + */
0,   /* detune fine 0 */
0,   /* detune octave 0 */
0,   /* detune note 0 */
0,   /* vibrato wave triangle */
0,   /* vibrato delay 0 */
50,  /* vibrato rate 50 */
0,   /* vibrato depth 0 */
0,8, /* dco 1 waveforms */
0,0, /* dca 1, dcw 1 key follows */
7,99,99,50,0,50,0,50,0,50,0,50,0,50,0,50,0,0,   /* dca 1 envelope */
7,99,99,50,0,50,0,50,0,50,0,50,0,50,0,50,0,0,   /* dcw 1 envelope */
7,50,0,50,0,50,0,50,0,50,0,50,0,50,0,50,0,0,   /* dco 1 envelope */
0,8, /* dco 2 waveforms */
0,0, /* dca 2, dcw 2 key follows */
7,99,99,50,0,50,0,50,0,50,0,50,0,50,0,50,0,0,   /* dca 2 envelope */
7,99,99,50,0,50,0,50,0,50,0,50,0,50,0,50,0,0,   /* dcw 2 envelope */
7,50,0,50,0,50,0,50,0,50,0,50,0,50,0,50,0,0,   /* dco 2 envelope */
0,   /* modulation */
0,0,0,15,   0,0,0,15           /* cz-1 parameters */
};

char fromcz1[7] = {0xF0,0x44,0x00,0x00,0x70,0x10,0x00};
char fromcz2[6] = {0xF0,0x44,0x00,0x00,0x70,0x30};
char fromcz3[2] = {0x70,0x31};

char tocz1[7] = {0xF0,0x44,0x00,0x00,0x70,0x20,0x00};
char tocz2[6] = {0xF0,0x44,0x00,0x00,0x70,0x30};

long midiptr; /* arguments for readsyn and writsyn */
int midierr;

char pvdltabl[202] =  {

0x00,0x00,   0x01,0x00,   0x02,0x00,   0x03,0x00,
0x04,0x00,   0x05,0x00,   0x06,0x00,   0x07,0x00,
0x08,0x00,   0x09,0x00,   0x0a,0x00,   0x0b,0x00,
0x0c,0x00,   0x0d,0x00,   0x0e,0x00,   0x0f,0x00,

0x10,0x00,   0x11,0x00,   0x12,0x00,   0x13,0x00,
0x14,0x00,   0x15,0x00,   0x16,0x00,   0x17,0x00,
0x18,0x00,   0x19,0x00,   0x1a,0x00,   0x1b,0x00,
0x1c,0x00,   0x1d,0x00,   0x1e,0x00,   0x1f,0x00,

0x21,0x00,   0x23,0x00,   0x25,0x00,   0x27,0x00,
0x29,0x00,   0x2b,0x00,   0x2d,0x00,   0x2f,0x00,
0x31,0x00,   0x33,0x00,   0x35,0x00,   0x37,0x00,
0x39,0x00,   0x3b,0x00,   0x3d,0x00,   0x3f,0x00,

0x43,0x00,   0x47,0x00,   0x4b,0x00,   0x4f,0x00,
0x53,0x00,   0x57,0x00,   0x5b,0x00,   0x5f,0x00,
0x63,0x00,   0x67,0x00,   0x6b,0x00,   0x6f,0x00,
0x73,0x00,   0x77,0x00,   0x7b,0x00,   0x7f,0x00,

0x87,0x00,   0x8f,0x00,   0x97,0x00,   0x9f,0x00,
0xa7,0x00,   0xaf,0x00,   0xb7,0x00,   0xbf,0x00,
0xc7,0x00,   0xcf,0x00,   0xd7,0x00,   0xdf,0x00,
0xe7,0x00,   0xef,0x00,   0xf7,0x00,   0xff,0x00,

0x0f,0x01,   0x1f,0x01,   0x2f,0x01,   0x3f,0x01,
0x4f,0x01,   0x5f,0x01,   0x6f,0x01,   0x7f,0x01,
0x8f,0x01,   0x9f,0x01,   0xaf,0x01,   0xbf,0x01,
0xcf,0x01,   0xdf,0x01,   0xef,0x01,   0xff,0x01,

0x1f,0x02,   0x3f,0x02,   0x5f,0x02,   0x7f,0x02,   0x00,0x03   } ;

char pvsdtabl[200] = {

0x20,0x00,   0x40,0x00,   0x60,0x00,   0x80,0x00,
0xa0,0x00,   0xc0,0x00,   0xe0,0x00,   0x00,0x01,
0x20,0x01,   0x40,0x01,   0x60,0x01,   0x80,0x01,
0xa0,0x01,   0xc0,0x01,   0xe0,0x01,   0x00,0x02,

0x20,0x02,   0x40,0x02,   0x60,0x02,   0x80,0x02,
0xa0,0x02,   0xc0,0x02,   0xe0,0x02,   0x00,0x03,
0x20,0x03,   0x40,0x03,   0x60,0x03,   0x80,0x03,
0xa0,0x03,   0xc0,0x03,   0xe0,0x03,   0x20,0x04,

0x60,0x04,   0xa0,0x04,   0xe0,0x04,   0x20,0x05,
0x60,0x05,   0xa0,0x05,   0xe0,0x05,   0x20,0x06,
0x60,0x06,   0xa0,0x06,   0xe0,0x06,   0x20,0x07,
0x60,0x07,   0xa0,0x07,   0xe0,0x07,   0x60,0x08,

0xe0,0x08,   0x60,0x09,   0xe0,0x09,   0x60,0x0a,
0xe0,0x0a,   0x60,0x0b,   0xe0,0x0b,   0x60,0x0c,
0xe0,0x0c,   0x60,0x0d,   0xe0,0x0d,   0x60,0x0e,
0xe0,0x0e,   0x60,0x0f,   0xe0,0x0f,   0xe0,0x10,

0xe0,0x11,   0xe0,0x12,   0xe0,0x13,   0xe0,0x14,
0xe0,0x15,   0xe0,0x16,   0xe0,0x17,   0xe0,0x18,
0xe0,0x19,   0xe0,0x1a,   0xe0,0x1b,   0xe0,0x1c,
0xe0,0x1d,   0xe0,0x1e,   0xe0,0x1f,   0xe0,0x21,

0xe0,0x23,   0xe0,0x25,   0xe0,0x27,   0xe0,0x29,
0xe0,0x2b,   0xe0,0x2d,   0xe0,0x2f,   0xe0,0x31,
0xe0,0x33,   0xe0,0x35,   0xe0,0x37,   0xe0,0x39,
0xe0,0x3b,   0xe0,0x3d,   0xe0,0x3f,   0xe0,0x43,

0xe0,0x47,   0xe0,0x4b,   0xe0,0x4f,   0xe0,0x53   };

char mamdtabl[10] = { 0x00,0x08,0x11,0x1a,0x24,0x2f,0x3a,0x45,0x52,0x5f } ;

char mwmdtabl[10] = { 0x00,0x1f,0x2c,0x39,0x46,0x53,0x60,0x6e,0x92,0xff } ;
char mwhvtabl[10] = { 0x00,0x19,0x33,0x4e,0x6a,0x86,0xa3,0xc1,0xdf,0xff } ;

char pvktabl[4] = { 0x08,0x04,0x20,0x02  } ;
 
FDB scrfdb;   /* mfdb for screen raster operations */

char *numtyp1[]= {" 1"," 2"," 3"," 4"," 5"," 6"," 7"," 8",
                   " 9","10","11","12","13","14","15","16"};
char *numtyp2[]= {"A1","A2","A3","A4","A5","A6","A7","A8",
                   "B1","B2","B3","B4","B5","B6","B7","B8"};
char *numtyp3[]= {"C1","C2","C3","C4","C5","C6","C7","C8",
                   "D1","D2","D3","D4","D5","D6","D7","D8"};
char *numtyp4[]= {"E1","E2","E3","E4","E5","E6","E7","E8",
                   "F1","F2","F3","F4","F5","F6","F7","F8"};
char *numtyp5[]= {"G1","G2","G3","G4","G5","G6","G7","G8",
                   "H1","H2","H3","H4","H5","H6","H7","H8"};
char *numtyp6[]= {"96","97","98","99","  ","  ","  ","  ",
                   "  ","  ","  ","  ","  ","  ","  ","  "};
long *numtype;
